#ifndef at858d_h
#define at858d_h

#if ( defined(__AVR_ATmega328P__) || defined(__AVR_ATmega328__) )
#define PB0 0  // Drive digit 0, (LSD).
#define PB1 1  // Drive opto-triac.
#define PB2 2  // Push button down.
#define PB3 3  // NC, not connected to anything.
#define PB4 4  // Handle internal switch.
#define PB5 5  // Push button up.
#define PB6 6  // Drive digit 2, (MSD).
#define PB7 7  // Drive digit 1.

#define PC0 0  // ADC, read the amplif. thermo couple voltage.
#define PC1 1  // NC, not connected to anything.
#define PC2 2  // ADC, Unknown use.
#define PC3 3  // Drive the TIP122 base (FAN ON/OFF control).
#define PC4 4  // NC, not connected to anything.
#define PC5 5  // ADC, read fan speed.
#define PC6 6  // NC, not connected to anything.

#define PD0 0  // Drive display segments: A.
#define PD1 1  // Drive display segments: E.
#define PD2 2  // Drive display segments: D.
#define PD3 3  // Drive display segments: F.
#define PD4 4  // Drive display decimal poin.
#define PD5 5  // Drive display segments: C.
#define PD6 6  // Drive display segments: G.
#define PD7 7  // Drive display segments: B.
#endif

#define FAN_OFF ( PORTC |= _BV(PC3) )
#define FAN_ON  ( PORTC &= ~_BV(PC3) )

// Set LOW PB0, PB7 and PB6 (common anode).
#define DISABLE_DIGITS ( PORTB &= ~( _BV(PB0) | _BV(PB7) | _BV(PB6) ) )
#define ALL_SEGS_OFF ( PORTD = 0xFF )  // Set all segments and decimal point to HIGH, or off. 

#define HEATER_ON ( PORTB &= ~_BV(PB1) )
#define HEATER_OFF ( PORTB |= _BV(PB1) )

#define SW0_PRESSED ( !(PINB & _BV(PB5)) )
#define SW1_PRESSED ( !(PINB & _BV(PB2)) )

#define REEDSW_CLOSED ( !(PINB & _BV(PB4)) )
#define REEDSW_OPEN ( PINB & _BV(PB4) )

// Correction factor to estimate the Atmel´s internal temperature, 
// this parameters varies from one chip to another.  
#define AT_OFFSET 328 // Atmel temperature offset error (327.897).    
#define AT_SLOPE 0.764 // Atmel temperature slope error (0.764).

#define INT_REF 1082400  // Atmel internal voltage reference in uV (1.0824V).
#define GAIN 57;  // If GAIN is 57, max. Tª is 459º C. 

#define POINTS_COUNT 29

#endif
